Subject: [OSPF] I have a question regarding forwarding address

From: Abhinay R <[email-masked]>
Date: Wed, 13 Jul 2016 17:41:05 +0530

Hi All,
        I have a question on when forwarding address is set in external
LSA?

Suppose I have a route from RIP say 100.1.1.0/24 with nexthop 10.1.1.1 in
routing table and I want to redistribute that route into OSPF, then I feel
below conditions must be vaild to set 10.1.1.1 as forwarding address in the
external LSA that OSPF originates for 100.1.1.0/24 network.

These conditions set the forwarding address field to a non-zero address:

    OSPF is enabled on the ASBR's next hop interface AND

    ASBR's next hop interface is non-passive under OSPF AND

    ASBR's next hop interface is not point-to-point AND

    ASBR's next hop interface is not point-to-multipoint AND

    ASBR's next hop interface address falls under the network range
specified in the router ospf command.

Any other conditions besides these set the forwarding address to 0.0.0.0.

If I have 10.1.1.0/24 network as intra or inter route in OSPF routing table
at the router that imported RIP route, do I originate External LSA with
10.1.1.1 set as forwarding address ?

There is a confusion that if the redistributed network nexthop is present
in routing table as intra inter or connected route, we need to set it as
forwarding address. Please clarify.

While we receive a External LSA with forwarding address set, then we see if
there is a connected, intra or inter route to that nexthop and then use it
to compute the route nexthop. This is clear.

Thanks & Regards,
Abhinay R

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Wed, 13 Jul 2016 13:59:24 +0000

Hi Abhinay,

Your questions are very implementation specific but since I’m a good guy…

From: OSPF <[email-masked]<mailto:[email-masked]>> on behalf of Abhinay R <[email-masked]<mailto:[email-masked]>>
Date: Wednesday, July 13, 2016 at 8:11 AM
To: OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: [OSPF] I have a question regarding forwarding address

Hi All,
        I have a question on when forwarding address is set in external LSA?

Suppose I have a route from RIP say 100.1.1.0/24<http://100.1.1.0/24> with nexthop 10.1.1.1 in routing table and I want to redistribute that route into OSPF, then I feel below conditions must be vaild to set 10.1.1.1 as forwarding address in the external LSA that OSPF originates for 100.1.1.0/24<http://100.1.1.0/24> network.

Although, it would be a strange topology where it weren’t enabled, it only has to be reachable within the OSPF routing domain as an intra or inter area route.

This should have no bearing on whether the forwarding address is advertised. There could be a better path through the OSPF routing domain independent of whether the interface is passive.

Although the likelihood of the forwarding address providing a better path is increased for multi-access networks, it is not necessary.

    ASBR's next hop interface address falls under the network range specified in the router ospf command.

Again, the next hop only has to be reachable within the OSPF routing domain as an intra or inter area route.

Hope the Helps,
Acee

If I have 10.1.1.0/24<http://10.1.1.0/24> network as intra or inter route in OSPF routing table at the router that imported RIP route, do I originate External LSA with 10.1.1.1 set as forwarding address ?

There is a confusion that if the redistributed network nexthop is present in routing table as intra inter or connected route, we need to set it as forwarding address. Please clarify.

While we receive a External LSA with forwarding address set, then we see if there is a connected, intra or inter route to that nexthop and then use it to compute the route nexthop. This is clear.

Thanks & Regards,
Abhinay R

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Wed, 13 Jul 2016 14:10:13 +0000

Hi Abhinay,

One more question answered inline.

From: OSPF <[email-masked]<mailto:[email-masked]>> on behalf of Acee Lindem <[email-masked]<mailto:[email-masked]>>
Date: Wednesday, July 13, 2016 at 9:59 AM
To: Abhinay R <[email-masked]<mailto:[email-masked]>>, OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: Re: [OSPF] I have a question regarding forwarding address

Hi Abhinay,

Hi All,

Hope the Helps,
Acee

This is implementation specific since if you a have an OSPF local RIB, you can do the lookup considering only OSPF routes. The criteria is that the route to the next hop is reachable in the OSPF routing domain via an intra-area or inter-area path. If you don’t have an OSPF local RIB, you need to handle this case (for other reasons as well).

Thanks,
Acee

Thanks & Regards,
Abhinay R

---

From: Abhinay R <[email-masked]>
Date: Wed, 13 Jul 2016 20:48:35 +0530

Hi Acee,
        According to "12.4.4. AS-external-LSAs" where forwarding address
example is given, I see that it states forwarding address will just help to
skip a extra hop to destination.
And don't you think if forwarding address is set to inter area nexthop,
then if that inter area route gets deleted. it will take time for that
change to reach the ASBR and then ASBR to compute the change and originate
new External LSA with no forwarding address.and this need to be flooded
across the AS and new route need to be installed in them, which will be
time consuming. So don't you think that forwarding address must be set if
the next hop is part of connected network ?

and is there any scenario where the nexthop will be intra or inter area
route, until the nexthop is explicitly set with routemap.

 12.4.4.1.  Examples of AS-external-LSAs

                Consider once again the AS pictured in Figure 6.  There
                are two AS boundary routers: RT5 and RT7.  Router RT5
                originates three AS-external-LSAs, for networks N12-N14.
                Router RT7 originates two AS-external-LSAs, for networks
                N12 and N15.  Assume that RT7 has learned its route to
                N12 via BGP, and that it wishes to advertise a Type 2
                metric to the AS.  RT7 would then originate the
                following LSA for N12:

        ; AS-external-LSA for Network N12,
        ; originated by Router RT7

        LS age = 0                  ;always true on origination
        Options = (E-bit)           ;
        LS type = 5                 ;AS-external-LSA
        Link State ID = N12's IP network number
        Advertising Router = Router RT7's ID
        bit E = 1                   ;Type 2 metric
        metric = 2
        Forwarding address = 0.0.0.0

Moy                         Standards Track                   [Page 140]

RFC 2328                     OSPF Version 2                   April 1998

                    In the above example, the forwarding address field
                    has been set to 0.0.0.0, indicating that packets for
                    the external destination should be forwarded to the
                    advertising OSPF router (RT7).  This is not always
                    desirable.  Consider the example pictured in Figure
                    16.  There are three OSPF routers (RTA, RTB and RTC)
                    connected to a common network.  Only one of these
                    routers, RTA, is exchanging BGP information with the
                    non-OSPF router RTX.  RTA must then originate AS-
                    external-LSAs for those destinations it has learned
                    from RTX.  By using the AS-external-LSA's forwarding
                    address field, RTA can specify that packets for
                    these destinations be forwarded directly to RTX.
                   * Without this feature, Routers RTB and RTC would take
                    an extra hop to get to these destinations.*

                    Note that when the forwarding address field is non-
                    zero, it should point to a router belonging to
                    another Autonomous System.

                    A forwarding address can also be specified for the
                    default route.  For example, in figure 16 RTA may
                    want to specify that all externally-destined packets
                    should by default be forwarded to its BGP peer RTX.
                    The resulting AS-external-LSA is pictured below.
                    Note that the Link State ID is set to
                    DefaultDestination.

        ; Default route, originated by Router RTA
        ; Packets forwarded through RTX

        LS age = 0                  ;always true on origination
        Options = (E-bit)           ;
        LS type = 5                 ;AS-external-LSA
        Link State ID = DefaultDestination  ; default route
        Advertising Router = Router RTA's ID
        bit E = 1                   ;Type 2 metric
        metric = 1
        Forwarding address = RTX's IP address

                    In figure 16, suppose instead that both RTA and RTB
                    exchange BGP information with RTX.  In this case,

Moy                         Standards Track                   [Page 141]

RFC 2328                     OSPF Version 2                   April 1998

                    RTA and RTB would originate the same set of AS-
                    external-LSAs.  These LSAs, if they specify the same
                    metric, would be functionally equivalent since they
                    would specify the same destination and forwarding
                    address (RTX).  This leads to a clear duplication of
                    effort.  If only one of RTA or RTB originated the
                    set of AS-external-LSAs, the routing would remain
                    the same, and the size of the link state database
                    would decrease.  However, it must be unambiguously
                    defined as to which router originates the LSAs
                    (otherwise neither may, or the identity of the
                    originator may oscillate).  The following rule is
                    thereby established: if two routers, both reachable
                    from one another, originate functionally equivalent
                    AS-external-LSAs (i.e., same destination, cost and
                    non-zero forwarding address), then the LSA
                    originated by the router having the highest OSPF
                    Router ID is used.  The router having the lower OSPF
                    Router ID can then flush its LSA.  Flushing an LSA
                    is discussed in Section 14.1.

                                +
                                |
                      +---+.....|.BGP
                      |RTA|-----|.....+---+
                      +---+     |-----|RTX|
                                |     +---+
                      +---+     |
                      |RTB|-----|
                      +---+     |
                                |
                      +---+     |
                      |RTC|-----|
                      +---+     |
                                |
                                +

               Figure 16: Forwarding address example

Thanks & Regards,

Abhinay R

On Wed, Jul 13, 2016 at 7:29 PM, Acee Lindem (acee) <[email-masked]> wrote:

> From: OSPF <[email-masked]> on behalf of Abhinay R <
> [email-masked]>
> To: OSPF WG List <[email-masked]>
> Although, it would be a strange topology where it weren’t enabled, it only
> has to be reachable within the OSPF routing domain as an intra or inter
> area route.
>
>
>
> This should have no bearing on whether the forwarding address is
> advertised. There could be a better path through the OSPF routing domain
> independent of whether the interface is passive.
>
>
>
> Although the likelihood of the forwarding address providing a better path
> is increased for multi-access networks, it is not necessary.
>
>
>
> If I have 10.1.1.0/24 network as intra or inter route in OSPF routing
> table at the router that imported RIP route, do I originate External LSA
> with 10.1.1.1 set as forwarding address ?
>
>
> While we receive a External LSA with forwarding address set, then we see
> if there is a connected, intra or inter route to that nexthop and then use
> it to compute the route nexthop. This is clear.
>
> Thanks & Regards,
> Abhinay R
>
>

-- 
~♥~♫AbHiNaY♫~♥~∞

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Wed, 13 Jul 2016 15:29:49 +0000

Hi Abhinay,

From: Abhinay R <[email-masked]<mailto:[email-masked]>>
Date: Wednesday, July 13, 2016 at 11:18 AM
To: Acee Lindem <[email-masked]<mailto:[email-masked]>>
Cc: OSPF WG List <[email-masked]<mailto:[email-masked]>>
Subject: Re: [OSPF] I have a question regarding forwarding address

Hi Acee,
        According to "12.4.4. AS-external-LSAs" where forwarding address example is given, I see that it states forwarding address will just help to skip a extra hop to destination.
And don't you think if forwarding address is set to inter area nexthop, then if that inter area route gets deleted. it will take time for that change to reach the ASBR and then ASBR to compute the change and originate new External LSA with no forwarding address.and this need to be flooded across the AS and new route need to be installed in them, which will be time consuming. So don't you think that forwarding address must be set if the next hop is part of connected network ?

No - the OSPF specification sets no such criteria. Although one might ask why a router in the area with the next-hop is not redistributing the route.

and is there any scenario where the nexthop will be intra or inter area route, until the nexthop is explicitly set with routemap.

I would not be a proponent of routing-policy which allows direct manipulation of the next-hop.

Note that the example you cite, is just an example. The specification doesn’t limit forwarding address advertisement to this use-case. Some implementations,  do limit advertisement to the most common use cases but this is not limited by the OSPF specification.

Thanks,
Acee
P.S. If I were to be designing OSPFv4, I would most likely omit the forwarding address feature (along with virtual links).

?

                    Without this feature, Routers RTB and RTC would take
                    an extra hop to get to these destinations.

?

                                +
                                |
                      +---+.....|.BGP
                      |RTA|-----|.....+---+
                      +---+     |-----|RTX|
                                |     +---+
                      +---+     |
                      |RTB|-----|
                      +---+     |
                                |
                      +---+     |
                      |RTC|-----|
                      +---+     |
                                |
                                +

Thanks & Regards,

Abhinay R

On Wed, Jul 13, 2016 at 7:29 PM, Acee Lindem (acee) <[email-masked]<mailto:[email-masked]>> wrote:
Hi Abhinay,

Hi All,

Hope the Helps,
Acee

Thanks & Regards,
Abhinay R

--
~♥~♫AbHiNaY♫~♥~∞